unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
  ObjComAuto, ExtCtrls;

type
  {$METHODINFO ON}
  TfrmMain = class(TForm, IDispatch)
    Panel1: TPanel;
    Label2: TLabel;
    mScript: TMemo;
    Panel2: TPanel;
    Label3: TLabel;
    mOutput: TMemo;
    Panel3: TPanel;
    Panel4: TPanel;
    sbExecuteE: TButton;
    Panel5: TPanel;
    Label4: TLabel;
    Label1: TLabel;
    Memo1: TMemo;
    Splitter1: TSplitter;
    procedure sbExecuteEClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function AddLineToMemo(const Text:string):HRESULT; safecall; // sample function
  published

  end;

  {$METHODINFO OFF}

var
  frmMain: TfrmMain;

implementation

uses
  pdScriptAPI;

{$R *.dfm}

///////////////////////////////////////////// Main form of demonstration project ///////////////////////////////////////////////
procedure TfrmMain.FormCreate(Sender: TObject);
var
  LibFileName:string;
begin
  // Look for an embedded pdScript interpreter located near the demo program
  LibFileName:=ExpandFileName(ExtractFilePath(ParamStr(0))+'..\..\..\pdScriptE.dll');
  if not fileexists(LibFileName) then
  begin
    LibFileName:=ExtractFilePath(ParamStr(0))+'pdScriptE.dll';
    if not fileexists(LibFileName) then
      LibFileName:='pdScriptE.dll';
  end;

  // load pdScript embedded interpreter
  if pdScriptLoad(LibFileName)=0 then
  begin
    sbExecuteE.Enabled:=False;
    ShowMessage('pdScript embedded interpreter was not found!'#13#10'Please ensure that pdScriptE.dll '+
      'library is available in the system search path, '#13#10'or place it near this demo program. Then restart the demo again.');
  end;
end;

procedure TfrmMain.sbExecuteEClick(Sender: TObject);
var
  prms:string;
  sLog:string;
  MyHostApp:TObjectDispatch;
begin
  try
    // Main form itself is passed to the script as an interface to host application
    MyHostApp:=TObjectDispatch.Create(Self,False);
    prms:='"/pds{host-interface='+IntToStr(Int64(MyHostApp))+',HostApp;}"';

    case Inline_pdScriptEx(mScript.Lines.Text,'',prms,False,sLog) of
      PDSCRIPT_RESULT_ERROR,
      PDSCRIPT_FATAL_ERROR:mOutput.Lines.Text:='Script Error:'#13#10+sLog;
      PDSCRIPT_NOT_LOADED:raise Exception.Create('Interpreter not found!');
    else
      mOutput.Lines.Text:=sLog;
    end;
  except
    on E:Exception do
    begin
      ShowMessage(e.message);
    end;
  end;
end;

function TfrmMain.AddLineToMemo(const Text:string):HRESULT;
begin
  Memo1.Lines.Add(Text);
end;

end.
